import javax.swing.*;
import java.awt.*;

public class DrawInput extends JFrame {
    String eingabe=null;

    public DrawInput() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setTitle("Zeichnen mit Java");
        setSize(400, 300);
        setVisible(true);
        eingabe = JOptionPane.showInputDialog(
                        "Bitte Eingabe!");
        repaint();
    }

    @Override public void paint(Graphics g) {
        Insets insets = getInsets();
        int links  = insets.left;
        int oben   = insets.top;
        int breite = getSize().width-insets.left-insets.right;
        int hoehe  = getSize().height-insets.top-insets.bottom;
        g.clearRect(links, oben, breite-1, hoehe-1);
        g.setColor(Color.black);
        if (eingabe != null) {
            g.drawString(eingabe, links+breite/2, oben+hoehe/2);
        } else {
            g.drawString("Problem mit Eingabe", links, oben+100);
        }
    }

    public static void main(String[] args) {
        new DrawInput();
    }
}

