package com.example.bermuda;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;

public class BermudaView extends View implements OnTouchListener {
    private Paint paint = new Paint();

    SpielFeld spielfeld = new SpielFeld();
    Rect rect = new Rect();
    boolean spielEnde = false;
    String statusStr = "                ";
    int distanz = 0;

    public BermudaView(Context context) {
        super(context);
        setFocusable(true);
        setFocusableInTouchMode(true);
        this.setOnTouchListener(this);
        paint.setAntiAlias(true);
    }
    
    @Override
    public void onDraw(Canvas canvas) {
    	if (distanz==0) { // initialisiere die Grafik
    		distanz = canvas.getWidth()/10;
    		rect.left = rect.top = 0;
    		rect.right = canvas.getWidth();
    		rect.bottom = canvas.getHeight();
    	}
        paint.setColor(Color.WHITE);
    	canvas.drawRect(rect, paint); // Schirm loeschen
        paint.setColor(Color.BLACK);
        String str;
        for (int i=0; i<spielfeld.MaxX; i++) {
            for (int j=0; j<spielfeld.MaxY; j++) {
                str = String.valueOf(spielfeld.get(i,j));
                canvas.drawText(str, (i+1)*distanz,
                                     (j+1)*distanz, paint);
            }
        }
    	canvas.drawText(statusStr, 0, 
    			(spielfeld.MaxY+1) * distanz, paint);
    }

    public boolean onTouch(View view, MotionEvent me) {
        if(me.getAction() != MotionEvent.ACTION_DOWN)
        	return super.onTouchEvent(me);
        if (!spielEnde) {
            int suchX = ((int)me.getX()-distanz/2)/distanz;
            int suchY = ((int)me.getY()-distanz/2)/distanz;
            if (suchX>=0 && suchY>=0 && suchX<spielfeld.MaxX
                         && suchY<spielfeld.MaxY) {
                char c = spielfeld.suche(suchX, suchY);
                if (c==spielfeld.SCHIFF) {
                    if (spielfeld.alleGefunden()) {
                        spielEnde = true;
                        statusStr =
                            "Gewonnen! Mausklick: neues Spiel";
                    }
                }
            }
        } else {
            // sonderfall: Mausklick, um Sieg zu bestaetigen
            spielEnde = false;
            statusStr = "                  ";
            spielfeld = new SpielFeld();
        }
        invalidate();
        return true;
    }
}


