import java.sql.*;
import java.util.Properties;

public class Embedded {
    final static String tableName = "artikel";
    final static String dbName = "derbyDB";

    public Embedded() {
         try {
            Class.forName("org.apache.derby.jdbc.EmbeddedDriver");
        } catch (ClassNotFoundException e) {
            System.out.println("JDBC-Treiber fehlt. Programmende.");
            System.exit(1);
        }
    }
    public static void main(String args[]) {
        Embedded db = new Embedded();
        try{
            Connection dbConnect = db.connect();
            if (!db.existiertTable(dbConnect)) {
                db.create(dbConnect);
            }
            if (args.length == 3) {
                db.insert(dbConnect, args);
            }
            db.selectAll(dbConnect);
            dbConnect.close();   // Datenbank schliessen
        } catch (SQLException e) {
            System.out.println(e.toString());
            System.out.println("Status: " + e.getSQLState());
            System.out.println("Error: " + e.getErrorCode());
        }
    }
    public Connection connect() throws SQLException {
        Properties properties = new Properties();
        properties.put("user", "arnold");
        properties.put("password", "geheim");
        Connection dbConnect = DriverManager.getConnection(
                 "jdbc:derby:"+dbName+";create=true", properties);
        return dbConnect;
    } 
    public boolean existiertTable(Connection connection) throws SQLException {
        ResultSet resultSet = connection.getMetaData()
                .getTables("%", "%", "%", new String[] { "TABLE" });
        int columnCnt = resultSet.getMetaData().getColumnCount();
        boolean existiert = false;
        while (resultSet.next() && !existiert) {
          System.out.println("Tabelle gefunden: " + resultSet.getString("TABLE_NAME"));
          if (resultSet.getString("TABLE_NAME").equalsIgnoreCase(tableName)) {
            existiert = true;
          }
        }
        resultSet.close();
        System.out.println("existiert die DB schon? "+existiert);
        return existiert;
    }
    public void create(Connection connection) throws SQLException {
        System.out.println("Creating Table " + tableName); 
        Statement statement = connection.createStatement();
        statement.execute("create table "+ tableName +" ( "
              + " name  varchar(32), "
              + " preis dec(10,2), "
              + " menge int "
              + " )");
        statement.close();
    }
    public void insert(Connection connection, String[] args) {
        for (int i=0; i<args.length; i++) {
            System.out.println(args[i]);
        }
        try {
            Statement statement = connection.createStatement();
            statement.execute("insert into "+ tableName 
                    + " (name, preis, menge) VALUES "
                    + " (\'"+args[0]+"\',"+args[1]+","+args[2]+" )");
            statement.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    public void selectAll(Connection dbConnect) throws SQLException {

        PreparedStatement sqlBefehl = dbConnect.prepareStatement(
                    "SELECT name, preis, menge FROM artikel");
        ResultSet sqlErgebnis = sqlBefehl.executeQuery();
        while (sqlErgebnis.next()) {
            System.out.print("Name: ");
            System.out.print(sqlErgebnis.getString("name"));
            System.out.print("Preis: ");
            System.out.println(sqlErgebnis.getDouble("preis"));
            System.out.print("Menge: ");
            System.out.println(sqlErgebnis.getDouble("menge"));
        }
        sqlErgebnis.close(); // Ergebnismenge schliessen
    }

    public void select2(Connection dbConnect) {
        try{
            dbConnect = DriverManager.getConnection(
                 "jdbc:derby:"+dbName,
                 "arnold",
                 "geheim");
            PreparedStatement sqlBefehl = dbConnect.prepareStatement(
                        "SELECT name, preis FROM artikel");
            ResultSet sqlErgebnis = sqlBefehl.executeQuery();
            while (sqlErgebnis.next()) {
                System.out.print("Name: ");
                System.out.print(sqlErgebnis.getString("name"));
                System.out.print("Preis: ");
                System.out.println(sqlErgebnis.getDouble("preis"));
            }
            sqlErgebnis.close(); // Ergebnismenge schliessen
            dbConnect.close();   // Datenbank schliessen
        } catch (SQLException e) {
            System.out.println(e.toString());
            System.out.println("Status: " + e.getSQLState());
            System.out.println("Error: " + e.getErrorCode());
        }
    }
}

