import java.sql.*;
import java.util.Properties;

public class ListBonbonbude {
    final static String dbName = "Bonbonbude";
    final static String tableName = "Artikel";

    public ListBonbonbude() {
         try {
            Class.forName("org.apache.derby.jdbc.EmbeddedDriver");
        } catch (ClassNotFoundException e) {
            System.out.println("derby.jar fehlt. Programmende.");
            System.exit(1);
        }
    }
    public static void main(String args[]) {
        ListBonbonbude db = new ListBonbonbude();
        try{
            Connection dbConnect = db.connect();
            if (args.length == 3) {
                db.insert(dbConnect, args);
            }
            db.selectAll(dbConnect);
            dbConnect.close();   // Datenbank schliessen
        } catch (SQLException e) {
            System.out.println(e.toString());
            System.out.println("Status: " + e.getSQLState());
            System.out.println("Error: " + e.getErrorCode());
        }
    }
    public Connection connect() throws SQLException {
        Properties properties = new Properties();
        properties.put("user", "arnold");
        properties.put("password", "geheim");
        Connection dbConnect = DriverManager.getConnection(
                 "jdbc:derby:"+dbName, properties);
        return dbConnect;
    } 
    public void create(Connection connection) throws SQLException {
        System.out.println("Creating Table " + tableName); 
        Statement statement = connection.createStatement();
        statement.execute("create table "+ tableName +" ( "
              + " name  varchar(32), "
              + " preis dec(10,2), "
              + " menge int "
              + " )");
        statement.close();
    }
    public void insert(Connection connection, String[] args) {
        for (int i=0; i<args.length; i++) {
            System.out.println(args[i]);
        }
        try {
            Statement statement = connection.createStatement();
            statement.execute("insert into "+ tableName 
                    + " (name, preis, menge) VALUES "
                    + " (\'"+args[0]+"\',"+args[1]+","+args[2]+" )");
            statement.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    public void selectAll(Connection connection) {
        try {
            Statement statement = connection.createStatement();
            ResultSet ergebnis = statement.executeQuery(
                    "SELECT name, preis, menge FROM artikel");
            while (ergebnis.next()) {
                System.out.print("Name: ");
                System.out.print(ergebnis.getString("name"));
                System.out.print(" | Preis: ");
                System.out.print(ergebnis.getDouble("preis"));
                System.out.print(" | Menge: ");
                System.out.println(ergebnis.getDouble("menge"));
            }
            ergebnis.close(); // Ergebnismenge schliessen
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}

